
inout double r(1:14000) 
inout double z(1:14000)
inout double p(1:14000) 
inout double q(1:14000) 
inout double x(1:14000) 
inout double rowstr(1:14000)
inout double colidx(1:102200)
inout double a(1:102200)
in integer n
inout double rho
inout double rho0
inout double alpha
inout double beta
inout double d
inout double sum


for i=0,14000 do
	rho = x(i)*x(i)
	r(i)=x(i)
	p(i) = r(i)
	q(i)=0.0
	z(i)=0.0
endfor

for i=1,25 do
	rho0 = rho
	d = 0.0	
	rho = 0.0
	
	for j=0,n do
		sum = 0.0
		for k=rowstr(j),rowstr(j+1)
			sum = sum + a(k)*p(colidx(k))
		endfor
		q(j)=sum
		d = d + p(j)*q(j)	
	endfor
	
	alpha = rho0/d
	
	for j=0,n do
		z(j)=z(j)+alpha*p(j)
		r(j)=r(j)-alpha*q(j)
	endfor
	
	for j=0,n do
		rho = rho+r(j)*r(j)
	endfor
	
	beta = rho / rho0
	
	for j=0,n do
		p(j)=r(j)+beta*p(j)
	endfor
	
endfor


