inout integer A(0:100)
inout integer B(0:100)
inout integer C(0:100)
inout integer n
inout integer a
inout integer b
inout integer a1
inout integer b1
inout integer c
inout integer d
in integer i
b = 1
b1 = 1
d = 2
for  i=3  to n do
  a = A(i) + B(i)
  C(i+1) = a * 2
  a = a +1
  b = A(i+1) + B(i+1)
  b = b +1
  A[i+1] = a * b
  A[i-1] = a + b
endfor

/* break load/store */
for  i=3  to n do
  tmp1 = A[i] 
  tmp2 = B[i]
  a = tmp1 + tmp2
  tmp3 = a * 2
  C(i+1) = tmp3 
  a = a +1
  tmp4 = A(i+1) 
  tmp5 = B(i+1)
  b = tmp4 + tmp5 
  b = b +1
  tmp6 = a * b
  A[i+1] = tmp6 
  tmp7 = a + b
  A[i-1] = tmp7 
endfor

/* stage generation */
for  i=3  to n do
stage 1................
  tmp1 = A[i] 
  tmp2 = B[i]
  tmp4 = A(i+1) 
  tmp5 = B(i+1)
stage 2................
  a = tmp1 + tmp2
  tmp3 = a * 2
  a = a +1
  b = tmp4 + tmp5 
  b = b +1
  tmp6 = a * b
  tmp7 = a + b
stage 3................
  C(i+1) = tmp3 
  A[i+1] = tmp6 
  A[i-1] = tmp7 
endfor

/* pipeline version: acced array bound in the last iteration */
  tmp1 = A[3] 
  tmp2 = B[3]
  tmp4 = A(3+1) 
  tmp5 = B(3+1)
for  i=3  to n do
stage 2................
  a = tmp1 + tmp2
  tmp3 = a * 2
  a = a +1
  b = tmp4 + tmp5 
  b = b +1
  tmp6 = a * b
  tmp7 = a + b
stage 3................
  C(i+1) = tmp3 
  A[i+1] = tmp6 
  A[i-1] = tmp7 
  tmp1 = A[i+1] 
  tmp2 = B[i+1]
  tmp4 = A(i+2) 
  tmp5 = B(i+2)
endfor

/* back to normal+verilog+
for  i=3  to n do
stage 1................
  memla1 <= A+i; 
  memla2 <= B+i;
  memla3 <= A+i+1; 
  memla4 <= B+i+1;
stage 2................
  a <= memlv1 + memlv2;
  tmp3 <= memlv1 + memlv2 * 2;
  a <= memlv1 + memlv2 +1;
  b <= memlv3 + memlv4; 
  b <= memlv3 + memlv4 +1;
  tmp6 <= (memlv1 + memlv2 +1) * (memlv3 + memlv4 +1);
  tmp7 <= memlv1 + memlv2 +1 * memlv3 + memlv4 +1
stage 3................
  memsa1 <= C+i+1; memsv1 <= tmp3 
  memsa2 <= A+i+1; memsv2 <= tmp6 
  memsa3 <= A+i-1; memsv3 <= tmp7 
endfor


/* back to normal
for  i=3  to n do
stage 1................
  memla1 <= A+i; 
  memla2 <= B+i;
  memla3 <= A+i+1; 
  memla4 <= B+i+1;
stage 2................
  a <= memlv1 + memlv2
  tmp3 = a * 2
  a = a +1
  b <= memlv3 + memlv4 
  b = b +1
  tmp6 = a * b
  tmp7 = a + b
stage 3................
  memsa1 <= C+i+1; memsv1 <= tmp3;
  memsa2 <= A+i+1; memsv2 <= tmp6;
  memsa3 <= A+i-1; memsv3 <= tmp7;
endfor

