! fir_basic: Does the basic FIR algorithm: store input sample, calculate
! output sample, move delay line
!	input    - the input sample data
!   ntaps    - the number of taps in the filter
!   h[]      - the FIR coefficient array
!   z[]      - the FIR delay line array
! 	accum 	 - has an answer
real input,save,store
out real accum
integer ntaps
real h(1:100),z(1:100)
! store input at the beginning of the delay line
z(0)=input
! calc FIR
accum=0
for i=1, ntaps do
	accum = accum+h(i)*z(i)
endfor
! shift delay line
store=z(1)
for j=1, ntaps-1 do
	save=z(j+1)
	z(j+1)=store
	store=save
endfor
